functor
import
   Application
   System
   NTCC at 'ntccModelChecker.ozf'
define
   Formula F Process P MC Evaluation NodesCE EdgesCE Structure
in
   F = unaryFormula(connector:'<>' child:binaryFormula(connector:'^' left:preposition(constraint:'in=true'#[vin '=:' 1]) right:unaryFormula(connector:'~' child:unaryFormula(connector:'o' child:preposition(constraint:'x=1'#[x '=:' 1]))))) % True
   %F = unaryFormula(connector:'[]' child:binaryFormula(connector:'->' left:preposition(constraint:'in=true'#[vin '=:' 1]) right:unaryFormula(connector:'o' child:preposition(constraint:'x=1'#[x '=:' 1])))) % False
   %F = unaryFormula(connector:'~' child:unaryFormula(connector:'[]' child:binaryFormula(connector:'v' left:unaryFormula(connector:'~' child:preposition(constraint:'in=true'#[vin '=:' 1])) right:unaryFormula(connector:'o' child:preposition(constraint:'x=1'#[x '=:' 1]))))) % True
   %F = unaryFormula(connector:'<>' child:binaryFormula(connector:'^' left:preposition(constraint:'in=true'#[vin '=:' 1]) right:unaryFormula(connector:'o' child:preposition(constraint:'x=2'#[x '=:' 2])))) % True
   %F = unaryFormula(connector:'<>' child:binaryFormula(connector:'v' left:unaryFormula(connector:'~' child:preposition(constraint:'in=true'#[vin '=:' 1])) right:unaryFormula(connector:'o' child:preposition(constraint:'x=1'#[x '=:' 1])))) % False
   %F = unaryFormula(connector:'~' child:unaryFormula(connector:'[]' child:binaryFormula(connector:'^' left:preposition(constraint:'in=true'#[vin '=:' 1]) right:unaryFormula(connector:'o' child:preposition(constraint:'x=2'#[x '=:' 2]))))) % False
   %F = unaryFormula(connector:'<>' child:binaryFormula(connector:'->' left:preposition(constraint:'in=true'#[vin '=:' 1]) right:unaryFormula(connector:'o' child:preposition(constraint:'x=1'#[x '=:' 1])))) % False
   %F = unaryFormula(connector:'[]' child:binaryFormula(connector:'v' left:unaryFormula(connector:'~' child:preposition(constraint:'in=true'#[vin '=:' 1])) right:unaryFormula(connector:'o' child:unaryFormula(connector:'~' child:preposition(constraint:'x=2'#[x '=:' 2]))))) % True
   %F = unaryFormula(connector:'[]' child:binaryFormula(connector:'v' left:unaryFormula(connector:'~' child:preposition(constraint:'in=true'#[vin '=:' 1])) right:unaryFormula(connector:'o' child:preposition(constraint:'x=2'#[x '=:' 2])))) % True
   %F = unaryFormula(connector:'[]' child:binaryFormula(connector:'->' left:preposition(constraint:'in=true'#[vin '=:' 1]) right:unaryFormula(connector:'o' child:preposition(constraint:'x=2'#[x '=:' 2])))) % True
   %F = unaryFormula(connector:'<>' child:binaryFormula(connector:'^' left:preposition(constraint:'in=true'#[vin '=:' 1]) right:unaryFormula(connector:'o' child:preposition(constraint:'x=1'#[x '=:' 1])))) % False
   %F = unaryFormula(connector:'~' child:unaryFormula(connector:'[]' child:unaryFormula(connector:'~' child:binaryFormula(connector:'^' left:preposition(constraint:'in=true'#[vin '=:' 1]) right:unaryFormula(connector:'o' child:preposition(constraint:'x=1'#[x '=:' 1])))))) % False
   %F = unaryFormula(connector:'~' child:unaryFormula(connector:'[]' child:unaryFormula(connector:'~' child:binaryFormula(connector:'^' left:preposition(constraint:'in=true'#[vin '=:' 1]) right:unaryFormula(connector:'o' child:unaryFormula(connector:'~' child:preposition(constraint:'x=2'#[x '=:' 2]))))))) % False
   %F = unaryFormula(connector:'[]' child:unaryFormula(connector:'~' child:binaryFormula(connector:'^' left:preposition(constraint:'in=true'#[vin '=:' 1]) right:unaryFormula(connector:'o' child:preposition(constraint:'x=1'#[x '=:' 1]))))) % True
   %F = unaryFormula(connector:'[]' child:unaryFormula(connector:'~' child:binaryFormula(connector:'^' left:preposition(constraint:'in=true'#[vin '=:' 1]) right:unaryFormula(connector:'o' child:unaryFormula(connector:'~' child:preposition(constraint:'x=2'#[x '=:' 2])))))) % True

   Formula = {New NTCC.ltlFormula init( F )}
   %{Formula setFormula( {Formula negation( $ )} )}
   {System.showInfo "The Property to check is:"}
   {System.showInfo {Formula showFormula( $ )}}
   {System.showInfo "---------------------------"}

   P = rep( par( [ when( [vin '=:' 1] next( tell( [x '=:' 2] ) ) ) unless( [vin '=:' 1] tell( [x '=:' 1] ) ) ] ) )
   Process = {New NTCC.ntccProcess init( P [vin x] 0#2 )}

   %Structure = {New NTCC.ntccStructure init( Process )}
   %{Structure showStructure}
   
   {System.showInfo "The Process to evaluate the property onto is:"}
   {System.showInfo {Process showProcess( $ )}}
   {System.showInfo "---------------------------"}

   MC = {New NTCC.ntccModelChecker init( Formula Process )}
   Evaluation#graph(nodes:NodesCE edges:EdgesCE) = {MC modelCheck( $ )}
   {System.printInfo "The property is... "}
   {System.show Evaluation}
   if {Not Evaluation} then
      {System.showInfo "A counter example is in the following trace of the store:"}
      for Node in {Reverse NodesCE} do
	 node(id:Id initial:_ state:State store:Store) = Node
      in
	 {System.showInfo "---State "#State#", ID "#Id#"---"}
	 {System.showInfo "Store:"}
	 for F in Store do
	    {System.printInfo {Formula showFormula( $ F )}}
	    {System.printInfo " "}
	 end
	 {System.showInfo ''}
      end
      {System.showInfo "---Edges---"}
      for Edge in EdgesCE do
	 {System.show Edge}
      end
   end
   
   {Application.exit 0}
end
